;; Copyright 2007, Greg Detre, Per Sederberg.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; test version of freex-conf. run this with 'emacs -q -l freex-conf-test.el'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; if you're starting a new testdocs, then in ipython:
;;
;;   from freex_sqlalchemy import * ; fsqa = create_fsqa('/home/greg/elisp/freex/testdocs/freex.db',False,False);


(add-to-list 'load-path "/home/greg/elisp/freex")

(autoload 'pymacs-load "pymacs" nil t)
(autoload 'pymacs-eval "pymacs" nil t)
(autoload 'pymacs-apply "pymacs")
(autoload 'pymacs-call "pymacs")
(eval-after-load "pymacs"
  '(add-to-list 'pymacs-load-path "/home/greg/elisp/freex/"))

;; where the freex .db file and its .freex friends will live.
;; make sure this directory exists
(setq freex-mode-dir "/home/greg/elisp/freex/testdocs/")

;; this needs to be set in the freex_sqlalchemy file_ext
;; class variable. the default is "freex". no dot needed
(setq freex-mode-ext "freex")

(setq freex-content-storage "mirror-files-to-db")

;; get Freex mode ready to go
(load "/home/greg/elisp/freex/freex-mode.el")

;; set it to load freex-mode when it sees a .freex
;; file
(setq auto-mode-alist
      (cons '("\\.freex\\'" . freex-mode)
            auto-mode-alist))

;; these tells the database to update itself automatically if 
;; there are any new files in the freex data directory, every 
;; time you save
;;
;; these resource intensive for large databases (> 1000
;; nuggets)
(add-hook 'freex-embed-save-hook 'freex-meta-update-index)
(add-hook 'freex-embed-save-hook 'freex-fontify-update-implicit-link-regexp)


;; this automatically tokenizes the filename by hyphens, and
;; adds all the parts as tags. very handy
(add-hook 'freex-meta-add-nugget-hooks
          'freex-meta-parse-alias-into-tag-parents)

;; this is the regex for finding files in the directory that
;; should be inserted into the db. the caret at the
;; beginning tells it to ignore files that have a dot in
;; front (useful for excluding emacs temp files), but it
;; also excludes any files with dots in them after the first
;; character, which annoys per. since my filenames don't
;; have dots in them, this is fine for me
(setq freex-mode-dir-filter "^[^.#]+\\.freex$")


